package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.OrderGoodsService;
import com.gxwebsoft.shop.entity.OrderGoods;
import com.gxwebsoft.shop.param.OrderGoodsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 订单商品记录表控制器
 *
 * @author 科技小王子
 * @since 2022-12-09 17:15:31
 */
@Api(tags = "订单商品记录表管理")
@RestController
@RequestMapping("/api/shop/order-goods")
public class OrderGoodsController extends BaseController {
    @Resource
    private OrderGoodsService orderGoodsService;

    @PreAuthorize("hasAuthority('shop:orderGoods:list')")
    @OperationLog
    @ApiOperation("分页查询订单商品记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<OrderGoods>> page(OrderGoodsParam param) {
        // 使用关联查询
        return success(orderGoodsService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:list')")
    @OperationLog
    @ApiOperation("查询全部订单商品记录表")
    @GetMapping()
    public ApiResult<List<OrderGoods>> list(OrderGoodsParam param) {
        // 使用关联查询
        return success(orderGoodsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:list')")
    @OperationLog
    @ApiOperation("根据id查询订单商品记录表")
    @GetMapping("/{id}")
    public ApiResult<OrderGoods> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(orderGoodsService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:save')")
    @OperationLog
    @ApiOperation("添加订单商品记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OrderGoods orderGoods) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          orderGoods.setUserId(loginUser.getUserId());
          orderGoods.setMerchantCode(getMerchantCode());
        }
        if (orderGoodsService.save(orderGoods)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:update')")
    @OperationLog
    @ApiOperation("修改订单商品记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OrderGoods orderGoods) {
        if (orderGoodsService.updateById(orderGoods)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:remove')")
    @OperationLog
    @ApiOperation("删除订单商品记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (orderGoodsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:save')")
    @OperationLog
    @ApiOperation("批量添加订单商品记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OrderGoods> list) {
        if (orderGoodsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:update')")
    @OperationLog
    @ApiOperation("批量修改订单商品记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OrderGoods> batchParam) {
        if (batchParam.update(orderGoodsService, "order_goods_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:remove')")
    @OperationLog
    @ApiOperation("批量删除订单商品记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (orderGoodsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
